<template>
  <div>
    <!--引用表格-->
    <BasicTable @register="registerTable">
      <!--插槽:table标题-->
      <template #tableTitle>
        <a-button type="primary" v-auth="'ggxjk-add'" @click="handleAdd" preIcon="ant-design:plus-outlined">新增</a-button>
        <a-button type="primary" v-auth="'ggxjk-key'" @click="handleKey">获取Key</a-button>
      </template>
      <!--操作栏-->
      <template #action="{ record }">
        <TableAction :actions="getTableAction(record)" />
      </template>
    </BasicTable>

    <!-- 表单区域 -->
    <GxjkModal @register="registerModal" @success="handleSuccess" />
    <GxjkKeyModal @register="registerKeyModal" @success="handleSuccess" />
  </div>
</template>

<script lang="ts" name="zcgl-ggxjk" setup>
  import { ref, computed, unref } from 'vue';
  import { BasicTable, useTable, TableAction } from '/@/components/Table';
  import { useModal } from '/@/components/Modal';
  import { useListPage } from '/@/hooks/system/useListPage';
  import GxjkModal from './modules/GxjkModal.vue';
  import GxjkKeyModal from './modules/GxjkKeyModal.vue';
  import { columns, searchFormSchema } from './data';
  import { list, deleteOne, batchDelete, getImportUrl, getExportUrl } from './api';
  import { useMessage } from '/@/hooks/web/useMessage';
  const { createMessage } = useMessage();
  //注册model
  const [registerModal, { openModal }] = useModal();
  const [registerKeyModal, { openModal: openKeyModal }] = useModal();
  //注册table数据
  const { prefixCls, tableContext, onExportXls, onImportXls } = useListPage({
    tableProps: {
      title: '共享接口',
      api: list,
      columns,
      canResize: false,
      showIndexColumn: true,
      formConfig: {
        labelWidth: 120,
        schemas: searchFormSchema,
        autoSubmitOnEnter: true,
        showAdvancedButton: true,
      },
      actionColumn: {
        width: 185,
      },
    },
    exportConfig: {
      name: '共享接口',
      url: getExportUrl,
    },
    importConfig: {
      url: getImportUrl,
    },
  });

  const [registerTable, { reload }, {}] = tableContext;

  /**
   * 新增事件
   */
  function handleAdd() {
    openModal(true, {
      isUpdate: false,
      showFooter: true,
    });
  }
  function handleKey() {
    openKeyModal(true, {
      showFooter: true,
    });
  }
  /**
   * 编辑事件
   */
  function handleEdit(record: Recordable) {
    openModal(true, {
      record,
      isUpdate: true,
      showFooter: true,
    });
  }
  /**
   * 删除事件
   */
  async function handleDelete(record) {
    await deleteOne({ id: record.id }, reload);
  }
  /**
   * 成功回调
   */
  function handleSuccess() {
    reload();
  }
  /**
   * 操作栏
   */
  function getTableAction(record) {
    return [
      {
        label: '编辑',
        onClick: handleEdit.bind(null, record),
        auth: 'ggxjk-edit',
      },
      {
        label: '删除',
        popConfirm: {
          title: '是否确认删除',
          confirm: handleDelete.bind(null, record),
        },
        auth: 'ggxjk-delete',
      },
    ];
  }
</script>
<style scoped></style>
